using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _segment_coder
{
    public partial class Form1 : Form
    {
        const int width = 20;
        const int height = 100;
        const int x = 20;
        const int y = 20;
        byte code = 0;
        Panel[] panels;
        byte[] segs = { 6, 5, 4, 3, 2, 1, 0, 7 };
        public Form1()
        {
            InitializeComponent();
            textBox4.Text = "65432107";
            panels= new Panel[8];
            for(int i = 0; i != 8; i++)
            {
                panels[i] = new Panel();
                panels[i].Click += new EventHandler(Form1_Click);
                panels[i].Name = i.ToString();
                panels[i].BackColor = Color.Black;
                panels[i].Parent = this;
                switch(i)
                {
                    case 0: panels[i].Width = height;
                            panels[i].Height = width;
                            panels[i].Location = new Point(x,y);
                            break;
                    case 1: panels[i].Width = width;
                            panels[i].Height = height + width;
                            panels[i].Location = new Point(x + height, y);
                            break;
                    case 2: panels[i].Width = width;
                            panels[i].Height = height + width;
                            panels[i].Location = new Point(x + height, y + width + height);
                            break;
                    case 3: panels[i].Width = height;
                            panels[i].Height = width;
                            panels[i].Location = new Point(x, y + height * 2 + width);
                            break;
                    case 4: panels[i].Width = width;
                            panels[i].Height = height;
                            panels[i].Location = new Point(x, y + width + height);
                            break;
                    case 5: panels[i].Width = width;
                            panels[i].Height = height;
                            panels[i].Location = new Point(x, y + width);
                            break;
                    case 6: panels[i].Width = height;
                            panels[i].Height = width;
                            panels[i].Location = new Point(x + width, y + height + width / 2);
                            break;
                    case 7: panels[i].Width = width;
                            panels[i].Height = width;
                            panels[i].Location = new Point(x + width + height, y + height * 2 + width * 2);
                            break;
                }
            }
            SetCode();
        }

        void  Form1_Click(object sender, EventArgs e)
        {
            byte seg = segs[(byte)(Convert.ToByte(((Panel)sender).Name))];
            if ((code & (1 << seg)) != 0)
            ((Panel)sender).BackColor = Color.Black;
            else
            ((Panel)sender).BackColor = Color.Red;
            toggle(seg);
        }

        void toggle(byte segment)
        {
            if (segment > 8)
                throw new Exception("Segment doesn't exists");
            code ^= (byte) (1 << segment);
            RefreshText();
        }

        void RefreshText()
        {
            byte code2 = code;
            if (checkBox1.Checked)
                code2 = Convert.ToByte(byte.MaxValue - code);
            textBox1.Text = code2.ToString();
            System.Text.StringBuilder sb = new StringBuilder();
                sb.Append(Convert.ToString(code2, 2).PadLeft(8, '0'));
            textBox2.Text = sb.ToString();
            textBox3.Text = "0x" + String.Format("{0:X2}", code2);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            RefreshText();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            int code2;
            try
            {
                code2 = Convert.ToInt32(textBox1.Text);
                if (checkBox1.Checked)
                    code2 = 255 - code2;
            }
            catch (Exception)
            { return; }
                if (code2 > 255)
                return;
            code = (byte)code2;
            SetCode();
        }

        void SetCode()
        {
            for (byte i = 0; i < 8; i++)
                if ((code & (1 << i)) != 0)
                {
                    if (panels[segs[i]].BackColor != Color.Red)
                        panels[segs[i]].BackColor = Color.Red;
                }
                else
                    if (panels[segs[i]].BackColor != Color.Black)
                        panels[segs[i]].BackColor = Color.Black;
            RefreshText();
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {
            byte[] undo = segs;
            try
            {
                for (int i = 0; i != 8; i++)
                    segs[i] = Convert.ToByte(textBox4.Text[i].ToString());
                SetCode();
            }
            catch (Exception) { segs = undo;}
        }
    }
}